# fundscli

[![oclif](https://img.shields.io/badge/cli-oclif-brightgreen.svg)](https://www.npmjs.com/package/@credenceanalytics/fundscli) [![Version](https://img.shields.io/npm/v/@credenceanalytics/fundscli.svg)](https://www.npmjs.com/package/@credenceanalytics/fundscli) [![Downloads/week](https://img.shields.io/badge/node-%3E=14.16.0-blue.svg?style=flat-square)](https://nodejs.org/download/release/v18.17.1/)

# Installation

## Prerequisites
`fundscli` installation need:
- Node.js >=18.17.1 ([*Download Link*](https://nodejs.org/download/release/v18.17.1/)) installed.
- Oracle Instant Client == 18.5.0.0 ([*Download Link*](https://www.oracle.com/in/database/technologies/instant-client/downloads.html)) installed.

### Online Mode

- `fundscli` is available in npm. To install it, type:
  ```bash
  $ npm i -g @credenceanalytics/fundscli
  ```


### Offline Mode

- Extract [fundscli.zip](https://cred-if.s3.ap-south-1.amazonaws.com/funds-cli.zip). 
  - Place the extracted `fundscli` folder to somewhere safe on your disk.

- Run `npm link --force` inside `fundscli` folder. (*This will start the installation process*)


- Test installation by typing following command:
  ```bash
  $ fundscli --help
  ```

# Commands

## `fundscli config:init`

Initialize the application. Takes input of paths of the JBOSS server directory and all the other microservice and creates a config.json file and stores the paths in it.

```
USAGE
  $ fundscli config:init
```

## `fundscli config:database`

Initialize or update the database details. For any errors reinitialize using [fundscli config:init](#fundscli-configinit) command.

```
USAGE
  $ fundscli config:database
```

## `fundscli config:java`

Update the java details in the JBOSS folder. For any errors reinitialize using config:init command.

```
USAGE
  $ fundscli config:java
```

## `fundscli config:mq`

Initialize the rabbitMq config files. For any errors reinitialize using config:init command.

```
USAGE
  $ fundscli config:mq
```

## `fundscli config:port`

Change the port for nrest and App Server application.

```
USAGE
  $ fundscli config:port
```

## `fundscli config:product`

Change the product details.

```
USAGE
  $ fundscli config:product
```

## `fundscli info:system`

Display system information on console.

```
USAGE
  $ fundscli info:system
```

## `fundscli extract:logs`

Extract logs from installed microservices and application (jboss/wildfly).

```
USAGE
  $ fundscli extract:logs
```

## `fundscli create:threaddump`

Creates java thread dump file for application (jboss/wildfly) in current working directory.

```
USAGE
  $ fundscli create:threaddump
```

## `fundscli migrate:decrypt`

Migrating encrypted configuration file to newer one.

```
USAGE
  $ fundscli migrate:decrypt
```

## `fundscli product:install`

Install all the application servers, microservices and apps on new Redhat Linux server and higher with dependency.

```
USAGE
  $ fundscli product:install
```

## `fundscli product:uninstall`

Uninstall all the application servers, microservices and apps with dependency, which were installed through `fundscli product:install` command.

```
USAGE
  $ fundscli product:uninstall
```

## `fundscli help [COMMAND]`

Display help for fundscli.

```
USAGE
  $ fundscli help [COMMAND]

ARGUMENTS
  COMMAND  command to show help for

OPTIONS
  --all  see all commands in CLI
```

# How To

You can find video tutorial of commands here.

- [`fundscli config:init`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/init.mp4)

- [`fundscli config:database`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/database.mp4)

- [`fundscli config:java`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/java.mp4)

- [`fundscli config:mq`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/rabbitmq.mp4)

- [`fundscli config:port`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/port.mp4)

- [`fundscli config:product`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/product.mp4)

- [`fundscli info:system`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/system.mp4)

- [`fundscli extract:logs`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/logs.mp4)

- [`fundscli create:threaddump`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/threaddump.mp4)

- [`fundscli product:install`](https://cred-if.s3.ap-south-1.amazonaws.com/ideafunds_CLI_Tools/Product-install.mp4)

# Troubleshooting Tips

For any errors, reinitialize using [fundscli config:init](#fundscli-configinit) command.
