// PACKAGES USED
const { Command } = require('@oclif/core');
const os = require('os');
const checkDiskSpace = require('check-disk-space').default;

class SystemInformationCommand extends Command {
    async run() {
        const byte = 0.000000000931,
            diskSpace = await checkDiskSpace(process.cwd());
        diskSpace.free = `${Math.round(diskSpace.free * byte)} GB`;
        diskSpace.size = `${Math.round(diskSpace.size * byte)} GB`;
        let systemInfo = {
            Architecture: os.arch(),
            OS: os.platform(),
            RAM: `${Math.round(os.totalmem() * byte)} GB`,
            'DISK SPACE': diskSpace,
            CPU: os.cpus(),
        };
        console.log(JSON.stringify(systemInfo, null, 4));
    }
}

SystemInformationCommand.description = `Store system information in a file`;
module.exports = SystemInformationCommand;
