const NodeRSA = require('node-rsa');
const key = new NodeRSA();
const fs = require('fs')
const logger = require('../utils/logger')

function isJsonFile(filePath) {
    try {
        const fileRead = fs.readFileSync(filePath, 'utf8')
        JSON.parse(fileRead)
        return true
    } catch (e) {
        return false
    }
}

const decryptOld = (filePath, publicPath, keyPath ,fileName) => {

    if (isJsonFile(filePath)) {
        logger.info(`${fileName} file has already been decrypted.`)
        return { status: "success" }
    } else {
        const publickey = fs.readFileSync(publicPath, 'utf8')
        key.importKey(publickey, 'pkcs8-public-pem')
        const encryptFile = fs.readFileSync(filePath, 'utf8')
        const decryptFile = key.decryptPublic(encryptFile, 'utf8')
        const parsed = JSON.parse(decryptFile)
        if (!parsed.PRIVATE_KEY) parsed.PRIVATE_KEY = keyPath
        fs.writeFileSync(filePath, JSON.stringify(parsed, null, "\t"))
        logger.info(`${fileName} file has been decrypted successfully`)
        return { status: "success" }
    }
}

module.exports = decryptOld
