const fs = require('fs');
const path = require('path');

const { logger } = require('./logger.js');

const fileChecker = (files, mode = 'log') => {
  let flag = true;
  files.map((file) => {
    if (typeof file === 'object') file = file.filePath;
    try {
      fs.accessSync(file, fs.constants.W_OK | fs.constants.R_OK | fs.constants.F_OK);
    } catch (err) {
      if (err.code === 'ENOENT') {
        if (mode === 'log') logger.error(`File not found: ${file}`);
        else {
          flag = 'Path not found, Enter correct path';
          return;
        }
        flag = false;
      } else {
        if (mode === 'log') logger.error(`Permission to read/write denied!: ${file}`);
        else {
          flag = `Permission to read/write denied!: ${file}`;
          return;
        }
        flag = false;
      }
    }
  });
  return flag;
};

const serviceFiles = (services, filePaths) => {
  let files = [];
  Object.keys(services).forEach((service) => {
    if (filePaths[service]) files.push(path.join(services[service], filePaths[service]));
  });
  return files;
};

module.exports = { fileChecker, serviceFiles };
