const fs = require('fs-extra');
const path = require('path');
const { exec } = require('child_process');
const os = require('os');

const { initLogger, CliError, HOME_DIR } = require(path.join(__dirname, '../logger.js'));

const logger = initLogger('product');

function nodeIntallation(directory) {
  try {
    if (!fs.existsSync(path.resolve(`${HOME_DIR}/credence/installation`))) {
      fs.mkdirSync(path.resolve(`${HOME_DIR}/credence/installation`));
    }

    if (!fs.existsSync(path.resolve(`${directory}/Microservices\\ Prerequisite/installations/node-v18.17.1-linux-x64.tar.gz`))) {
      logger.error(`The provide path for installation files is incorrect : ${directory}`);
    }

    exec(`sudo cp ${directory}/Microservices\\ Prerequisite/installations/node-v18.17.1-linux-x64.tar.gz ${HOME_DIR}/credence/installation`, (error, stdout, stderr) => {
      if (error) {
        logger.error(error + 'error');
      }
      if (stderr) {
        logger.error(stderr + 'stderr');
      }
      if (stdout) {
        logger.info(stdout + 'stdout');
      }
    });

    if (!fs.existsSync(path.resolve(`${HOME_DIR}/credence/installation/node-v18.17.1-linux-x64`))) {
      exec(`sudo tar -xvf node-v18.17.1-linux-x64.tar.gz`, { cwd: `${HOME_DIR}/credence/installation` }, (error, stdout, stderr) => {
        if (error) {
          logger.error(error);
        }
        if (stderr) {
          logger.error(stderr);
        }
        if (stdout) {
          logger.info(stdout);
        }
      });
    }

    if (!fs.existsSync(path.resolve(`${HOME_DIR}/.bash_profile`))) {
      fs.writeFile(`${HOME_DIR}/.bash_profile`, `export JAVA_HOME=\"/usr/java/jdk\" \n export PATH=$PATH:$JAVA_HOME/bin`, (err) => {
        if (err) {
          logger.error(err);
        }
      });
    } else {
      fs.readFile(`${HOME_DIR}/.bash_profile`, (error, data) => {
        if (error) {
          logger.error('cannot read .bash_profile due to ' + error);
        }
        if (!data.includes(`export NODEJS_HOME=${HOME_DIR}/credence/installation/node-v18.17.1-linux-x64`)) {
          fs.appendFile(`${HOME_DIR}/.bash_profile`, `export NODEJS_HOME=${HOME_DIR}/credence/installation/node-v18.17.1-linux-x64`, (err) => {
            if (err) {
              logger.error(`Cannot edit .bash_profile due to ${err}`);
            }
          });
        }
      });
    }

    exec('source ~/.bash_profile', (error, stdout, stderr) => {
      if (error) {
        logger.error('error : ' + error);
      }
      if (stderr) {
        logger.error('stderr : ' + stderr);
      }
      if (stdout) {
        logger.info('stdout : ' + stdout);
      }
    });
  } catch (error) {
    logger.error(`Error occurred : ${error}`);
    throw new CliError(`Error due to : ${error}`);
  }
}

module.exports = { nodeIntallation };
