const logger = require('./logger')
const KeyCommand = require('../commands/generate/keys')
const configMq = require('../commands/config/mq')
const configProduct = require('../commands/config/product')
const configDatabase = require('../commands/config/database')

exports.runKeyGenrateCommandInternally = async()=>{
    const keyCommand = new KeyCommand([], {});
    logger.info('Generating private and public key files...');
    let data = await keyCommand.run();
    return data
}

exports.runmqcommandinternally = async() =>{
    const configMqCommand = new configMq([], {})
    logger.info('Running MQ password encryption command...');
    let mqData = await configMqCommand.run()
    return mqData
}

exports.runproductcommandinternally = async() =>{
    const configProductCommand = new configProduct([], {})
    logger.info('Running Product encryption command...');
    let ProductData = await configProductCommand.run()
    return ProductData
}

exports.rundbcommandinternally = async() =>{
    const configDatabaseCommand = new configDatabase([], {})
    logger.info('Running Datatbase encryption command...');
    let configData = await configDatabaseCommand.run()
    return configData
}